#include "stdafx.h"
#include"draw.h"
#include "base.h"
#include <stdio.h>
//
#define DEFAULT_WIDTH 320
#define DEFAULT_HEIGHT 240
#define DEFAULT_COLOR 16
//HWND m_hWnd;
#define E_EXIT_CODE 1000

#define m_hWnd Handle.hWnd
CDraw::CDraw(HWND h)
{
	if(h==NULL){
		//ftHg̓AvP[VB̃EBhEnh
		CBaseWnd wnd;
		h=wnd.Get();
	}
	AlphaDepth=256;AlphaColor=0;
	BG_ScrollMode=1;
	BG_ScrollSize=256;
	ZoomFlag=0;
	SelectDCFlag=0;
	GetDesktopColor();
	BackBufferDC=NULL;
	BGDC=NULL;
	BGSurfaceDC=NULL;
	MaxSpritePage=SPRITE_SURFACE_MAX;
	for(int a=0;a<SPRITE_SURFACE_MAX;++a){
		SpriteDC[a]=NULL;
		hSpriteBmp[a]=NULL;
		hMaskBmp[a]=NULL;
	}
	hBackBufferBmp=NULL;
	hBGBmp=NULL;
	hBGSurfaceBmp=NULL;
	SetHWND(h);
	SetScreen(DEFAULT_WIDTH,DEFAULT_HEIGHT);//DEFAULT_COLOR);
	SpriteMode=1;
	InitSprite();
	ShowBenchFlag=0;
	strcpy(FontName[0],"lr ");
	strcpy(FontName[1],"lr SVbN");
	strcpy(FontName[2],"MS UI Gothic");
	strcpy(FontName[3],"Arial Black");//"Wingdings");
	FontType=0;
	SetBGScroll(0,0);
	SetViewAreaSize(-1,-1);
	PenSize(1);
	ExitFlag=0;
}
void CDraw::SetHWND(HWND h)
{
	if(m_hDC)
		ReleaseDC(m_hWnd,m_hDC);
	m_hWnd=h;
	m_hDC=GetDC(m_hWnd);
}
void CDraw::SetScreen(int width, int height, int color, int page)
{
	if(width>0 && width<=1600)
		Display_Width=width;
	if(height>0 && height<1200)
		Display_Height=height;
	if(color==8 || color==16 || color==24 || color==32)
		Display_Color=color;
	else
		Display_Color=DesktopColor;
	if(page>0 && page<=SPRITE_SURFACE_MAX)
		MaxSpritePage=page;
	CreateSurface(page);
}
CDraw::~CDraw()
{
	ExitCDraw();
	DeleteSurface();
	if(ExitFlag==0)
		ReleaseDC(m_hWnd,m_hDC);
	else
		DeleteDC(m_hDC);
}
void CDraw::SetExitCode()
{
	//I
	if(ExitFlag)
		return;
	ExitFlag=1;
	HDC DC=CreateCompatibleDC(m_hDC);
	ReleaseDC(m_hWnd,m_hDC);
	m_hDC=DC;
	//EBhEDCjƃfXNgbvɃS~ĉŃ_~[DC`B
}

void CDraw::Pset(int x, int y, int color,int page)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	SetPixelV(hDC,x,y,color);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x,y,1,1);
}
COLORREF CDraw::Pget(int x, int y,int page)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
				break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	return(GetPixel(hDC,x,y));
}
void CDraw::Line(int x1,int y1,int x2,int y2,int color,int page)
{//΍W
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	POINT ps;
	HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
	HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
	MoveToEx(hDC,x1,y1,&ps);
	LineTo(hDC,x1+x2,y1+y2);
	SetPixelV(hDC,x1+x2,y1+y2,color);
	SelectObject(hDC,hPenOld);
	DeleteObject(hPen);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x1,y1,x2,y2);

}
void CDraw::Line2(int x1,int y1,int x2,int y2,int color,int page)
{//΍W
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	POINT ps;
	HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
	HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
	MoveToEx(hDC,x1,y1,&ps);
	LineTo(hDC,x2,y2);
	SetPixelV(hDC,x2,y2,color);
	SelectObject(hDC,hPenOld);
	DeleteObject(hPen);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x1,y1,x2,y2);

}

void CDraw::Arc(int x,int y,int r,int color,int page)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
	HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
	HBRUSH hbr=CreateSolidBrush(color);
	HBRUSH hbrold=(HBRUSH)SelectObject(hDC,hbr);
//	Ellipse(hDC,x-r,y-r,x+r,y+r);
//	AngleArc(hDC, x, y, r, 0.0, 3.14);
	::Arc(hDC, x-r, y-r, x+r, y+r, 0, 0,0, 0);
	SelectObject(hDC,hPenOld);
	SelectObject(hDC,hbrold);
	DeleteObject(hPen);
	DeleteObject(hbr);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x-r,y-r,r*2,r*2);
}

void CDraw::Circle(int x,int y,int r,int color,int page)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
	HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
	HBRUSH hbr=CreateSolidBrush(color);
	HBRUSH hbrold=(HBRUSH)SelectObject(hDC,hbr);
	Ellipse(hDC,x-r,y-r,x+r,y+r);
	SelectObject(hDC,hPenOld);
	SelectObject(hDC,hbrold);
	DeleteObject(hPen);
	DeleteObject(hbr);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x-r,y-r,r*2,r*2);
}


void CDraw::ClearSurface(int page)
{//T[tFXNA
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case -3:
				hDC=BackBufferDC;
				break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	int Color=0;
	if(page>=0) Color=SpriteColor[page];
	HBRUSH hbr=CreateSolidBrush(Color);
	RECT r;
	r.left=0;
	r.top=0;
	r.right=Display_Width+1;
	r.bottom=Display_Height+1;
	FillRect(hDC,&r,hbr);
	DeleteObject(hbr);
}
void CDraw::BoxFill(int x1, int y1, int x2, int y2, int color,int page)
{

	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case -3:
				hDC=BackBufferDC;
				break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	HBRUSH hbr=CreateSolidBrush(color);
	RECT r;
	r.left=x1;
	r.top=y1;
	r.right=x1+x2+1;
	r.bottom=y1+y2+1;
	FillRect(hDC,&r,hbr);
	DeleteObject(hbr);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x1,y1,x2,y2);
}
void CDraw::Box(int x1, int y1, int x2, int y2, int color,int page)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}

	POINT p[5];
	p[0].x=x1;
	p[0].y=y1;
	p[1].x=x1;
	p[1].y=y1+y2;
	p[2].x=x1+x2;
	p[2].y=y1+y2;
	p[3].x=x1+x2;
	p[3].y=y1;
	p[4].x=x1;
	p[4].y=y1;
	HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
	HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
	Polyline(hDC,p,5);
	SelectObject(hDC,hPenOld);
	DeleteObject(hPen);
	if(page>=0)
		MakeMaskData(page,SpriteColor[page],x1,y1,x2,y2);
}
void CDraw::DrawTextBold(char* text,int x,int y,int Color,int Size,int page,int Color2)
{//Color2Ńt`t̕`
	//`
	DrawText2(text,x-1,y+0,Color2,Size,page,1);
	DrawText2(text,x+1,y+0,Color2,Size,page,1);
	DrawText2(text,x+0,y-1,Color2,Size,page,1);
	DrawText2(text,x+0,y+1,Color2,Size,page,1);
	//
/*
	DrawText(text,x-1,y-1,Color2,Size,page,paintflag);
	DrawText(text,x+1,y-1,Color2,Size,page,paintflag);
	DrawText(text,x-1,y+1,Color2,Size,page,paintflag);
	DrawText(text,x+1,y+1,Color2,Size,page,paintflag);
	*/
	//`
	DrawText2(text,x,y,Color,Size,page,1);
	if(page>=0){
		int len=strlen(text);
		MakeMaskData(page,SpriteColor[page],x-1,y-1,len*(Size/2)+2,Size+2);
	}
}
void CDraw::DrawText2(char * Text, int x, int y, int Color, int Size,int page,int paintflag)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}
	HFONT hFont=CreateFont(Size,0, 0, 0,
		FW_DONTCARE	, FALSE, FALSE, FALSE, 
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS 
	, CLIP_DEFAULT_PRECIS,	DEFAULT_QUALITY	,
	DEFAULT_PITCH | FF_ROMAN	, FontName[FontType]);

	if(paintflag)
		SetBkMode(hDC, TRANSPARENT);

	HFONT hFontOld=(HFONT)SelectObject(hDC,hFont);
	SetTextColor(hDC,Color);
	int len=strlen(Text);
	TextOut(hDC,x,y,Text,len);
	SelectObject(hDC,hFontOld);
	DeleteObject(hFont);
//	if(page>=0 && paintflag==1)
//		MakeMaskData(page,SpriteColor[page],x-1,y-1,len*(Size/2)+2,Size+2);

}
void CDraw::DrawText(char * Text, int x, int y, int Color, int Size,int page,int paintflag)
{
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}


	HFONT hFont=CreateFont(Size,0, 0, 0,
		FW_DONTCARE	, FALSE, FALSE, FALSE, 
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS 
	, CLIP_DEFAULT_PRECIS,	DEFAULT_QUALITY	,
	DEFAULT_PITCH | FF_ROMAN	,FontName[FontType]);

	if(paintflag)
		SetBkMode(hDC, TRANSPARENT);
	else
		SetBkMode(hDC, OPAQUE);

	HFONT hFontOld=(HFONT)SelectObject(hDC,hFont);
	SetTextColor(hDC,Color);
	int len=strlen(Text);
	TextOut(hDC,x,y,Text,len);
	SelectObject(hDC,hFontOld);
	DeleteObject(hFont);
	if(page>=0 && paintflag==1)
		MakeMaskData(page,SpriteColor[page],x-1,y-1,len*(Size/2)+2,Size+2);

}
void CDraw::PutBitmap(HBITMAP hBmp,int x,int y,int w,int h,int page)
{
	if(hBmp==NULL)
		return;
	HDC hDC=m_hDC;
	if(SpriteMode){
		switch(page){
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
				hDC=SpriteDC[page];
			break;
			case -1:
				hDC=BGSurfaceDC;
			break;
			case -2:
				hDC=BGDC;
			break;
			case DRAW_SELECT:
				if(SelectDCFlag==0)
					hDC=m_hDC;
				else
					hDC=BGSurfaceDC;
				break;
			default:
				hDC=m_hDC;
			break;
		}
	}

	BITMAP bmp;
	GetObject(hBmp,sizeof(BITMAP),&bmp);
	if(w==-1 || h==-1){
		w=bmp.bmWidth;
		h=bmp.bmHeight;
	}
	HDC hMemDC=CreateCompatibleDC(hDC);
	HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
	BitBlt(hDC,x,y,w,h,hMemDC,0,0,SRCCOPY);
	SelectObject(hMemDC,hBmpOld);
	DeleteDC(hMemDC);
}
HBITMAP CDraw::ReadBitmap(LPSTR FileName)
{
	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
//	LPVOID dib;
//	if(hBmp==NULL)
//		hBmp=CreateCompatibleDIBBitmap(Display_Width,Display_Height,32,&dib);
//	SetHBITMAP(hBmp);
	return(hBmp);
}
void CDraw::LoadBGData(LPSTR FileName)
{
	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	LPVOID dib;
	if(hBmp==NULL)
		hBmp=CreateCompatibleDIBBitmap(Display_Width,Display_Height,32,&dib);
	HDC hMemDC=CreateCompatibleDC(m_hDC);
	HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
	BITMAP bmp;
	GetObject(hBmp,sizeof(BITMAP),&bmp);
	BitBlt(BGDC,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);
	SelectObject(hMemDC,hBmpOld);
	DeleteDC(hMemDC);
	DeleteObject(hBmp);
	SetSelectDefaultDC(1);//ftHgBGɂ
}
void CDraw::PutBGChip(int x,int y,int w,int h,int src_x,int src_y)
{
	if(SpriteMode==0)
		BitBlt(m_hDC,x,y,w,h,BGDC,src_x,src_y,SRCCOPY);
	else
		BitBlt(BGSurfaceDC,x,y,w,h,BGDC,src_x,src_y,SRCCOPY);
}
void CDraw::SetBGScroll(int x,int y)
{
	BG_ScrollX=x;
	BG_ScrollY=y;
}
RECT CDraw::LoadSpriteData(LPSTR FileName,int color,int page)
{
	RECT rc={0,0,0,0};
	if(page<0 || page>=SPRITE_SURFACE_MAX)
		return rc;
	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	LPVOID dib;
	if(hBmp==NULL)
		hBmp=CreateCompatibleDIBBitmap(Display_Width,Display_Height,32,&dib);
	HDC hMemDC=CreateCompatibleDC(m_hDC);
	HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
	BITMAP bmp;
	GetObject(hBmp,sizeof(BITMAP),&bmp);
	SpriteColor[page]=100;//_~[
	BoxFill(0,0,bmp.bmWidth,bmp.bmHeight,0xffffff,page);//}XNNA邽
	SpriteColor[page]=color;
	BitBlt(SpriteDC[page],0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);
	SelectObject(hMemDC,hBmpOld);
	DeleteDC(hMemDC);
	DeleteObject(hBmp);
	MakeMaskData(page);
	SetSelectDefaultDC(1);//ftHgBGɂ
	rc.left=0;rc.top=0;
	rc.right=bmp.bmWidth;
	rc.bottom=bmp.bmHeight;
	return rc;

}
void CDraw::PutSpriteChip(int x,int y,int w,int h,int src_x,int src_y,int page,int zoomx,int zoomy,int hflag)
{
	if(SpriteMode==0){
		BitBlt(m_hDC,x,y,w,h,MaskDC[page],src_x,src_y,SRCAND);
		BitBlt(m_hDC,x,y,w,h,SpriteDC[page],src_x,src_y,SRCPAINT);
	}else{
		if(zoomx || zoomy){
			switch(hflag){
				default:
					StretchBlt(BackBufferDC,x,y,zoomx,zoomy,MaskDC[page],src_x,src_y,w,h,SRCAND);
					StretchBlt(BackBufferDC,x,y,zoomx,zoomy,SpriteDC[page],src_x,src_y,w,h,SRCPAINT);
				break;
				case 1://E]
					StretchBlt(BackBufferDC,x+zoomx,y,-zoomx,zoomy,MaskDC[page],src_x,src_y,w,h,SRCAND);
					StretchBlt(BackBufferDC,x+zoomx,y,-zoomx,zoomy,SpriteDC[page],src_x,src_y,w,h,SRCPAINT);
				break;
			}
		}else{
			switch(hflag){
				default:
					{
						BitBlt(BackBufferDC,x,y,w,h,MaskDC[page],src_x,src_y,SRCAND);
						BitBlt(BackBufferDC,x,y,w,h,SpriteDC[page],src_x,src_y,SRCPAINT);
					}
					break;
				case 1://E]
					StretchBlt(BackBufferDC,x+w,y,-w,h,MaskDC[page],src_x,src_y,w,h,SRCAND);
					StretchBlt(BackBufferDC,x+w,y,-w,h,SpriteDC[page],src_x,src_y,w,h,SRCPAINT);
					break;
			
				case 4:
					{//Z
						unsigned short int* dib1=(unsigned short int*)BackDIB;
						unsigned short int* dib2=(unsigned short int*)SpriteDIB[page];
						if(BackDIB==NULL || SpriteDIB[page]==NULL){
							//MessageBeep(0);
							return;
						}
						int dx,dy,sx=0,sy=0;
						if((x+w)>Display_Width){
							w=Display_Width-x;
						}
						if((y+h)>Display_Height){
							h=Display_Height-y;
						}
						if(x<0){
							sx=-x;w=w+x;x=0;
						}
						if(y<0){
							sy=-y;h=h+y;y=0;
						}
						if(x<Display_Width && y<Display_Height){
							if(TrueColorBit==15){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x3e0;
										int g2=c2 & 0x3e0;
										int r1=c1 & 0x7c00;
										int r2=c2 & 0x7c00;
										r1+=r2;if(r1> 0x7c00) r1=0x7c00;
										g1+=g2;if(g1> 0x3e0) g1=0x3e0;
										b1+=b2;if(b1> 0x1f) b1=0x1f;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
							if(TrueColorBit==16){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x7e0;
										int g2=c2 & 0x7e0;
										int r1=c1 & 0xf800;
										int r2=c2 & 0xf800;
										r1+=r2;if(r1> 0xf800) r1=0xf800;
										g1+=g2;if(g1> 0x7e0) g1=0x7e0;
										b1+=b2;if(b1> 0x1f) b1=0x1f;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
								/*
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width] |=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
									}
								}*/
							}
							if(TrueColorBit==32){
								unsigned int* dib1=(unsigned int*)BackDIB;
								unsigned int* dib2=(unsigned int*)SpriteDIB[page];
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0xff;
										int b2=c2 & 0xff;
										int g1=c1 & 0xff00;
										int g2=c2 & 0xff00;
										int r1=c1 & 0xff0000;
										int r2=c2 & 0xff0000;
										r1+=r2;if(r1> 0xff0000) r1=0xff0000;
										g1+=g2;if(g1> 0xff00) g1=0xff00;
										b1+=b2;if(b1> 0xff) b1=0xff;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
						}
					}
				break;
				case 5:
					{
						unsigned short int* dib1=(unsigned short int*)BackDIB;
						unsigned short int* dib2=(unsigned short int*)SpriteDIB[page];
						int dx,dy,sx=0,sy=0;
						if((x+w)>Display_Width){
							w=Display_Width-x;
						}
						if((y+h)>Display_Height){
							h=Display_Height-y;
						}
						if(x<0){
							sx=-x;w=w+x;x=0;
						}
						if(y<0){
							sy=-y;h=h+y;y=0;
						}
						if(x<Display_Width && y<Display_Height){
							if(TrueColorBit==15){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x3e0;
										int g2=c2 & 0x3e0;
										int r1=c1 & 0x7c00;
										int r2=c2 & 0x7c00;
										r1+=r2;if(r1> 0x7c00) r1=0x7c00;
										g1+=g2;if(g1> 0x3e0) g1=0x3e0;
										b1+=b2;if(b1> 0x1f) b1=0x1f;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
							if(TrueColorBit==16){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x7e0;
										int g2=c2 & 0x7e0;
										int r1=c1 & 0xf800;
										int r2=c2 & 0xf800;
										r1+=r2;if(r1> 0xf800) r1=0xf800;
										g1+=g2;if(g1> 0x7e0) g1=0x7e0;
										b1+=b2;if(b1> 0x1f) b1=0x1f;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
								/*
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width] |=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
									}
								}*/
							}
							if(TrueColorBit==32){
								unsigned int* dib1=(unsigned int*)BackDIB;
								unsigned int* dib2=(unsigned int*)SpriteDIB[page];
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0xff;
										int b2=c2 & 0xff;
										int g1=c1 & 0xff00;
										int g2=c2 & 0xff00;
										int r1=c1 & 0xff0000;
										int r2=c2 & 0xff0000;
										r1+=r2;if(r1> 0xff0000) r1=0xff0000;
										g1+=g2;if(g1> 0xff00) g1=0xff00;
										b1+=b2;if(b1> 0xff) b1=0xff;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
						}
					}
					break;
				case 8:
					{//
						unsigned short int* dib1=(unsigned short int*)BackDIB;
						unsigned short int* dib2=(unsigned short int*)SpriteDIB[page];
						if(BackDIB==NULL || SpriteDIB[page]==NULL){
							//MessageBeep(0);
							return;
						}
						int dx,dy,sx=0,sy=0;
						if((x+w)>Display_Width){
							w=Display_Width-x;
						}
						if((y+h)>Display_Height){
							h=Display_Height-y;
						}
						if(x<0){
							sx=-x;w=w+x;x=0;
						}
						if(y<0){
							sy=-y;h=h+y;y=0;
						}
						if(x<Display_Width && y<Display_Height){
							if(TrueColorBit==15){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x3e0;
										int g2=c2 & 0x3e0;
										int r1=c1 & 0x7c00;
										int r2=c2 & 0x7c00;
										r1+=r2;r1>>=1;r1&=0x7c00;if(r1> 0x7c00) r1=0x7c00;
										g1+=g2;g1>>=1;g1&=0x3e0;if(g1> 0x3e0) g1=0x3e0;
										b1+=b2;b1>>=1;b1&=0x1f;if(b1> 0x1f) b1=0x1f;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
							if(TrueColorBit==16){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x7e0;
										int g2=c2 & 0x7e0;
										int r1=c1 & 0xf800;
										int r2=c2 & 0xf800;
										r1+=r2;r1>>=1;r1&=0xf800;if(r1> 0xf800) r1=0xf800;
										g1+=g2;g1>>=1;g1&=0x7e0;if(g1> 0x7e0) g1=0x7e0;
										b1+=b2;b1>>=1;b1&=0x1f;if(b1> 0x1f) b1=0x1f;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
							if(TrueColorBit==32){
								unsigned int* dib1=(unsigned int*)BackDIB;
								unsigned int* dib2=(unsigned int*)SpriteDIB[page];
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned int c1=dib1[x+dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0xff;
										int b2=c2 & 0xff;
										int g1=c1 & 0xff00;
										int g2=c2 & 0xff00;
										int r1=c1 & 0xff0000;
										int r2=c2 & 0xff0000;
										r1+=r2;r1>>=1;r1&=0xff0000;if(r1> 0xff0000) r1=0xff0000;
										g1+=g2;g1>>=1;g1&=0xff00;if(g1> 0xff00) g1=0xff00;
										b1+=b2;b1>>=1;b1&=0xff;if(b1> 0xff) b1=0xff;
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
						}
					}
				break;
				case 9:
					{
						unsigned short int* dib1=(unsigned short int*)BackDIB;
						unsigned short int* dib2=(unsigned short int*)SpriteDIB[page];
						int dx,dy,sx=0,sy=0;
						if((x+w)>Display_Width){
							w=Display_Width-x;
						}
						if((y+h)>Display_Height){
							h=Display_Height-y;
						}
						if(x<0){
							sx=-x;w=w+x;x=0;
						}
						if(y<0){
							sy=-y;h=h+y;y=0;
						}
						if(x<Display_Width && y<Display_Height){
							if(TrueColorBit==15){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x3e0;
										int g2=c2 & 0x3e0;
										int r1=c1 & 0x7c00;
										int r2=c2 & 0x7c00;
										r1+=r2;r1>>=1;r1&=0x7c00;if(r1> 0x7c00) r1=0x7c00;
										g1+=g2;g1>>=1;g1&=0x3e0;if(g1> 0x3e0) g1=0x3e0;
										b1+=b2;b1>>=1;b1&=0x1f;if(b1> 0x1f) b1=0x1f;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
							if(TrueColorBit==16){
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned short int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned short int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0x1f;
										int b2=c2 & 0x1f;
										int g1=c1 & 0x7e0;
										int g2=c2 & 0x7e0;
										int r1=c1 & 0xf800;
										int r2=c2 & 0xf800;
										r1+=r2;r1>>=1;r1&=0xf800;if(r1> 0xf800) r1=0xf800;
										g1+=g2;g1>>=1;g1&=0x7e0;if(g1> 0x7e0) g1=0x7e0;
										b1+=b2;b1>>=1;b1&=0x1f;if(b1> 0x1f) b1=0x1f;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
								/*
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										dib1[x+dx+(Display_Height-1-dy-y)*Display_Width] |=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
									}
								}*/
							}
							if(TrueColorBit==32){
								unsigned int* dib1=(unsigned int*)BackDIB;
								unsigned int* dib2=(unsigned int*)SpriteDIB[page];
								for(dy=0;dy<h;++dy){
									for(dx=0;dx<w;++dx){
										unsigned int c1=dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width];
										unsigned int c2=dib2[sx+dx+src_x+(Display_Height-1-src_y-dy-sy)*Display_Width];
										int b1=c1 & 0xff;
										int b2=c2 & 0xff;
										int g1=c1 & 0xff00;
										int g2=c2 & 0xff00;
										int r1=c1 & 0xff0000;
										int r2=c2 & 0xff0000;
										r1+=r2;r1>>=1;r1&=0xff0000;if(r1> 0xff0000) r1=0xff0000;
										g1+=g2;g1>>=1;g1&=0xff00;if(g1> 0xff00) g1=0xff00;
										b1+=b2;b1>>=1;b1&=0xff;if(b1> 0xff) b1=0xff;
										dib1[x+w-dx+(Display_Height-1-dy-y)*Display_Width]=r1 | g1 | b1;
									}
								}
							}
						}
					}
					break;
			}
		}
	}
}
HBITMAP CDraw::CreateCompatibleDIBBitmap(int x,int y,int color,LPVOID *lpDIB)
{

//	int z=sizeof(HBITMAP);
	static HBITMAP hBufferBmp;

		BITMAPINFO bmpinfo;
		bmpinfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bmpinfo.bmiHeader.biWidth=x;
		bmpinfo.bmiHeader.biHeight=y;//̐Ȃgbv_Echa
		bmpinfo.bmiHeader.biPlanes=1;
		bmpinfo.bmiHeader.biBitCount=color;//J[
		if(color>=16)
			bmpinfo.bmiHeader.biCompression=BI_RGB;
		else
			bmpinfo.bmiHeader.biCompression=BI_RGB;//BI_RLE8;

		bmpinfo.bmiHeader.biSizeImage=0;
		bmpinfo.bmiHeader.biXPelsPerMeter=0;
		bmpinfo.bmiHeader.biYPelsPerMeter=0;
		bmpinfo.bmiHeader.biClrUsed=0;
		bmpinfo.bmiHeader.biClrImportant=256;

		LPVOID pDIB;
		HDC hDC=GetDC(NULL);
		if(color>=16){
			hBufferBmp = CreateDIBSection(hDC, &bmpinfo, DIB_RGB_COLORS, &pDIB, NULL, NULL);
		}else{
			hBufferBmp = CreateDIBSection(hDC, &bmpinfo, DIB_PAL_COLORS, &pDIB, NULL, NULL);
		}
		ReleaseDC(NULL,hDC);
		*lpDIB=pDIB;

	return(hBufferBmp);
}

/*
HDC CPaint::HBitmap2DC(HBITMAP hBmp)
{
	if(hSaveDC){
		SelectObject(hSaveDC,hSaveBmp_Old);
//		DeleteObject(hSaveBmp_Old);
		DeleteDC(hSaveDC);
		hSaveDC=0;
	}
	HDC hDC=GetDC(NULL);
	hSaveDC=CreateCompatibleDC(hDC);
	hSaveBmp_Old=(HBITMAP)SelectObject(hSaveDC,hSaveBmp);
	ReleaseDC(NULL,hDC);
	return(hSaveDC);
}
void CPaint::DeleteBitmap()
{
	if(hSaveBmp){
		SelectObject(hSaveDC,hSaveBmp_Old);
		DeleteDC(hSaveDC);
		DeleteObject(hSaveBmp);
		hSaveBmp=NULL;
	}
}


void CPaint::PutBitmap(int x, int y, int xx, int yy,int sx,int sy,int xx2,int yy2)
{
	HDC hDC;
	if(Wpage)
		hDC=hBackPageDC;
	else
		hDC=hViewDC;
	HBitmap2DC(hSaveBmp);
	ChangePalette(hSaveDC);
	BITMAP bmp;
	GetObject(hSaveBmp,sizeof(BITMAP),&bmp);
	int Width=bmp.bmWidth;
	int Height=bmp.bmHeight;
	if(xx==-1 || yy==-1){
		if(xx2!=0 || yy2!=0)
			StretchBlt(hDC,x,y,Width,Height,hSaveDC,sx,sy,xx2,yy2,SRCCOPY);
		else
			BitBlt(hDC,x,y,Width,Height,hSaveDC,sx,sy,SRCCOPY);
	}else{
		if(xx2!=0 || yy2!=0)
			StretchBlt(hDC,x,y,xx,yy,hSaveDC,sx,sy,xx2,yy2,SRCCOPY);
		else{
			if(xx>Width)
				xx=Width;
			if(yy>Height)
				yy=Height;
			BitBlt(hDC,x,y,xx,yy,hSaveDC,sx,sy,SRCCOPY);
		}
	}
}

*/



BOOL CDraw::SaveBitmapFile(LPSTR FileName, HBITMAP hBmp,int X,int Y,int Width,int Height,int Color)
{
	HBITMAP OriginalBmpOld;
	HDC OriginalDC;
	int flag=0;
	if(Color!=8 && Color!=16 && Color!=24 && Color!=32)
		return FALSE;
	if(X==-1)
		X=0;
	if(Y==-1)
		Y=0;
	HDC hDC=GetDC(m_hWnd);
	if(hBmp==NULL){
		if(SelectDCFlag==0){
		//	hBmp=hBackPageBmp;
			OriginalDC=hDC;
			flag=1;
			RECT r;
			GetClientRect(m_hWnd, &r);
			if(Width==-1)
				Width=r.right-r.left;
			if(Height==-1)
				Height=r.bottom-r.top;
		}else{
			hBmp=hBackBufferBmp;
			OriginalDC=BackBufferDC;
			flag=1;
		}
	}
	BITMAP bmp;
	if(hBmp!=NULL){
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		if(Width==-1)
			Width=bmp.bmWidth;
		if(Height==-1)
			Height=bmp.bmHeight;
	}
	LPVOID AreaDIB;
	HBITMAP AreaBmp=CreateCompatibleDIBBitmap(Width,Height,Color,&AreaDIB);
	if(AreaDIB==NULL){
		ReleaseDC(m_hWnd,hDC);
		return FALSE;
	}
	HDC AreaDC=CreateCompatibleDC(hDC);
	if(flag==0){
		OriginalDC=CreateCompatibleDC(hDC);
		OriginalBmpOld=(HBITMAP)SelectObject(OriginalDC,hBmp);
	}
	HBITMAP AreaBmpOld=(HBITMAP)SelectObject(AreaDC,AreaBmp);
	BitBlt(AreaDC,0,0,Width,Height,OriginalDC,X,Y,SRCCOPY);
	SelectObject(AreaDC,AreaBmpOld);
	if(flag==0){
		SelectObject(OriginalDC,OriginalBmpOld);
		DeleteDC(OriginalDC);
	}
	DeleteDC(AreaDC);
	ReleaseDC(m_hWnd,hDC);

	char *data=(char *)AreaDIB;
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	int size=Width*Height*(Color/8);
	bf.bfType=0x4d42;
	bf.bfSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+size;
	if(Color>8)
		bf.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER);
	else
		bf.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+(256 * sizeof(RGBQUAD));
	bi.biSize=sizeof(BITMAPINFOHEADER);
	bi.biWidth=Width;
	bi.biHeight=Height;
	bi.biPlanes=1;
	bi.biBitCount=Color;
	bi.biCompression=0;
	bi.biSizeImage=0;//size;
	bi.biClrUsed=0;
	bi.biClrImportant=0;
	bi.biXPelsPerMeter=0;
	bi.biYPelsPerMeter=0;

	size=Width*Height*(Color/8);
	FILE *fp;
	fp=fopen(FileName,"wb");
	if(fp){
		fwrite(&bf,1,sizeof(BITMAPFILEHEADER),fp);
		fwrite(&bi,1,sizeof(BITMAPINFOHEADER),fp);
		if(Color==8){
			RGBQUAD Palette[256];
			for(int a=0;a<256;++a){
				Palette[a].rgbBlue=a;
				Palette[a].rgbGreen=a;
				Palette[a].rgbRed=a;
			}
			//fwrite(Palette,1,256 * sizeof(RGBQUAD),fp);
			fwrite(Palette,1,256 * sizeof(RGBQUAD),fp);
		}
		fwrite(data,1,size,fp);
		fclose(fp);
	}else{
		DeleteObject(AreaBmp);
		return FALSE;
	}
	DeleteObject(AreaBmp);
	return TRUE;
}



void CDraw::CreateSurface(int page)
{
	LPVOID dib;
	DeleteSurface();
	if(BG_ScrollSize<Display_Width) BG_ScrollSize=Display_Width;
	if(BG_ScrollSize<Display_Height) BG_ScrollSize=Display_Height;
	hBackBufferBmp=CreateCompatibleDIBBitmap(Display_Width,Display_Height,Display_Color,&BackDIB);
	hBGBmp=CreateCompatibleDIBBitmap(Display_Width,Display_Height,Display_Color,&dib);
	if(BG_ScrollMode==0)
		hBGSurfaceBmp=CreateCompatibleDIBBitmap(Display_Width*2,Display_Height*2,Display_Color,&dib);
	else{
		hBGSurfaceBmp=CreateCompatibleDIBBitmap(BG_ScrollSize,BG_ScrollSize,Display_Color,&dib);
	}
	BackBufferDC=CreateCompatibleDC(m_hDC);
	BGDC=CreateCompatibleDC(m_hDC);
	BGSurfaceDC=CreateCompatibleDC(m_hDC);
	hBackBufferBmp_old=(HBITMAP)SelectObject(BackBufferDC,hBackBufferBmp);
	hBGBmp_old=(HBITMAP)SelectObject(BGDC,hBGBmp);
	hBGSurfaceBmp_old=(HBITMAP)SelectObject(BGSurfaceDC,hBGSurfaceBmp);
	for(int a=0;a<MaxSpritePage;++a){
		hSpriteBmp[a]=CreateCompatibleDIBBitmap(Display_Width,Display_Height,Display_Color,&SpriteDIB[a]);
		hMaskBmp[a]=CreateCompatibleDIBBitmap(Display_Width,Display_Height,Display_Color,&MaskDIB[0]);
		SpriteDC[a]=CreateCompatibleDC(m_hDC);
		MaskDC[a]=CreateCompatibleDC(m_hDC);
		hSpriteBmp_old[a]=(HBITMAP)SelectObject(SpriteDC[a],hSpriteBmp[a]);
		hMaskBmp_old[a]=(HBITMAP)SelectObject(MaskDC[a],hMaskBmp[a]);
	}
	GetColorBit();//F̃rbg擾
//	BoxFill(0,0,Display_Width,Display_Height,RGB(0,0,255),-1);


}

void CDraw::DeleteSurface()
{
	if(hBackBufferBmp)
		SelectObject(BackBufferDC,hBackBufferBmp_old);
	if(hBGBmp)
		SelectObject(BGDC,hBGBmp_old);
	if(hBGSurfaceBmp)
		SelectObject(BGSurfaceDC,hBGSurfaceBmp_old);
	//
	if(BackBufferDC)
		DeleteDC(BackBufferDC);
	if(BGDC)
		DeleteDC(BGDC);
	if(BGSurfaceDC)
		DeleteDC(BGSurfaceDC);
	//
	if(hBackBufferBmp)
		DeleteObject(hBackBufferBmp);
	if(hBGBmp)
		DeleteObject(hBGBmp);
	if(hBGSurfaceBmp)
		DeleteObject(hBGSurfaceBmp);
	hBackBufferBmp=hBGBmp=hBGSurfaceBmp=NULL;
	//
	for(int a=0;a<SPRITE_SURFACE_MAX;++a){
		if(hSpriteBmp[a])
			SelectObject(SpriteDC[a],hSpriteBmp_old[a]);
		if(hMaskBmp[a])
			SelectObject(MaskDC[a],hMaskBmp_old[a]);
		if(SpriteDC[a])
			DeleteDC(SpriteDC[a]);
		if(MaskDC[a])
			DeleteDC(MaskDC[a]);
		if(hSpriteBmp[a])
			DeleteObject(hSpriteBmp[a]);
		if(hMaskBmp[a])
			DeleteObject(hMaskBmp[a]);
		hSpriteBmp[a]=hMaskBmp[a]=NULL;
		SpriteDIB[a]=MaskDIB[a]=NULL;
	}

}

void CDraw::MakeMaskData(int page,int color,int sx,int sy,int w,int h)//}XN쐬B
{
	if(Display_Color<16 || page>=SPRITE_SURFACE_MAX)
		return;
	unsigned int* dib;
	int x,y;
	unsigned int color2=0;
	if(color!=-1)
		SpriteColor[page]=color;
	unsigned int sc=SpriteColor[page] & 0xfffffe;//rfIJ[hɂĂ̓A`GCAX邽
	if(SpriteColor[page]==0xffffffff)//F
		return;
	if(sx<0)sx=0;
	if(sy<0)sy=0;
	if(w==-1){
		w=Display_Width-sx;
		color2=-1;
	}
	if(h==-1){
		h=Display_Height-sy;
		color2=-1;
	}
	if((w+sx)>Display_Width)
		w=Display_Width-sx;
	if((h+sy)>Display_Height)
		h=Display_Height-sy;
	HBITMAP DummyBmp=CreateCompatibleDIBBitmap(Display_Width,-Display_Height,32,(LPVOID*)&dib);
	HDC MemDC=CreateCompatibleDC(m_hDC);
	HBITMAP hBmpOld=(HBITMAP)SelectObject(MemDC,DummyBmp);
	BitBlt(MemDC,sx,sy,w,h,SpriteDC[page],sx,sy,SRCCOPY);
	for(y=sy;y<sy+h;++y){
		for(x=sx;x<sx+w;++x){
			if((dib[x+y*Display_Width]& 0xfffffe)==sc || (dib[x+y*Display_Width])==color2)
				dib[x+y*Display_Width]=0xffffffff;
			else
				dib[x+y*Display_Width]=0;
		}
	}
	BitBlt(MaskDC[page],sx,sy,w,h,MemDC,sx,sy,SRCCOPY);//}XN`
	//L̓
	BitBlt(MemDC,sx,sy,w,h,SpriteDC[page],sx,sy,SRCCOPY);
//	BitBlt(MemDC,0,0,Display_Width,Display_Height,SpriteDC[page],0,0,SRCCOPY);
	for(y=sy;y<sy+h;++y){
		for(x=sx;x<sx+w;++x){
			if((dib[x+y*Display_Width]& 0xfffffe)==sc)
				dib[x+y*Display_Width]=0;
		}
	}
	BitBlt(SpriteDC[page],sx,sy,w,h,MemDC,sx,sy,SRCCOPY);
	//
	SelectObject(MemDC,DummyBmp);
	DeleteDC(MemDC);
	DeleteObject(DummyBmp);
}
void CDraw::MoveBGScroll()
{
	//BG_ScrollX,BG_ScrollYɂT[tFXɏ
	int x1=0,y1=0,x2=0,y2=0,x3=0,y3=0,x4=0,y4=0;
	int w1=0,h1=0,w2=0,h2=0,w3=0,h3=0,w4=0,h4=0;
	if(BG_ScrollX==0 && BG_ScrollY==0){
		BitBlt(BackBufferDC,0,0,Display_Width,Display_Height,BGSurfaceDC,0,0,SRCCOPY);
		return;
	}
	x1=BG_ScrollX;y1=BG_ScrollY;
	w1=BG_ScrollSize-BG_ScrollX;
	h1=BG_ScrollSize-BG_ScrollY;
	if(w1>=Display_Width){
		w1=Display_Width;w2=0;w3=0;w4=0;
	}else{

		w2=w4=Display_Width-w1;
	}
	if(h1>=Display_Height){
		h1=Display_Height;h2=0;h3=0;h4=0;
	}else{
		h3=h4=Display_Height-h1;
	}
	BitBlt(BackBufferDC,0,0,w1,h1,BGSurfaceDC,x1,y1,SRCCOPY);
	if(w2)
		BitBlt(BackBufferDC,w1,0,w2,h1,BGSurfaceDC,0,y1,SRCCOPY);
	if(h3)
		BitBlt(BackBufferDC,0,h1,w1,h3,BGSurfaceDC,x1,0,SRCCOPY);
	if(h4 || w4)
		BitBlt(BackBufferDC,w1,h1,w4,h4,BGSurfaceDC,0,0,SRCCOPY);

}
void CDraw::SetAlpha(int level,int color)
{
	if(level<0)level=0;
	if(level>256)level=256;
	AlphaDepth=level;
	AlphaColor=color;
}
void CDraw::AlphaBlt()
{
	if(Display_Color!=16 || AlphaDepth==256)
		return;
	short int* dib=(short int*)BackDIB;
	if(dib==NULL){
		//MessageBeep(0);
		return;
	}
	int x,y,r,g,b;
	int revbit=(256-AlphaDepth);
	r=(AlphaColor)&255;r>>=3;
	g=(AlphaColor>>8)&255;r>>=3;
	b=(AlphaColor>>16)&255;r>>=3;
	int color1=AlphaColor;
	if(TrueColorBit==15){
		//15rbg@5,5,5
		for(y=0;y<Display_Height;++y){
			for(x=0;x<Display_Width;++x){
				int c=dib[x+y*Display_Width];
				r=(((c>>10)&31)*AlphaDepth)>>8;
				g=(((c>>5 )&31)*AlphaDepth)>>8;
				b=(( c     &31)*AlphaDepth)>>8;
				dib[x+y*Display_Width]=(r<<10) | (g<<5) | b;
				//dib[x+y*Display_Width]=(dib[x+y*Display_Width]>>1) & 0x3def;//011 1101 1110 1111
			}
		}
	}else{
		//16rbg 5,6,5
		for(y=0;y<Display_Height;++y){
			for(x=0;x<Display_Width;++x){
				int c=dib[x+y*Display_Width];
				r=(((c>>11)&31)*AlphaDepth)>>8;
				g=(((c>>5 )&63)*AlphaDepth)>>8;
				b=(( c     &31)*AlphaDepth)>>8;
				dib[x+y*Display_Width]=(r<<11) | (g<<5) | b;
				//dib[x+y*Display_Width]=(dib[x+y*Display_Width]>>1) & 0x3def;//011 1101 1110 1111
			}
		}
	}
}
/*void CDraw::DrawEnd()
{
	SpriteMode=-1;
}*/
void CDraw::UpDate()
{
	if(IsWindow(m_hWnd)==FALSE){
		SetExitCode();
		return;
	}
	if(SelectDCFlag==0)
		return;
	static int count=0;
	static int time1=0,time2=0;
	static int frame=0;
	if(SpriteMode==1){
		//BoxFill(0,0,Display_Width,Display_Height,RGB(0,0,255),-3);
		if(BG_ScrollMode==0)
			BitBlt(BackBufferDC,0,0,Display_Width,Display_Height,BGSurfaceDC,0,0,SRCCOPY);
		else
			MoveBGScroll();
		int i;
		for(i=(MAX_SPRITE-1);i>=0;--i){
			if(SpriteAt[i].panum>=0){
				PutSpriteChip(SpriteAt[i].x,SpriteAt[i].y,SpriteAt[i].w,SpriteAt[i].h,SpriteAt[i].px,SpriteAt[i].py,SpriteAt[i].page,SpriteAt[i].zoomx,SpriteAt[i].zoomy,SpriteAt[i].hflag);
			}
		}
		//
		AlphaBlt();

		//
		int w=Display_Width,h=Display_Height;
		if(ZoomFlag==0){
			if(ViewAreaWidth>0 && w>ViewAreaWidth)
				w=ViewAreaWidth;
			if(ViewAreaHeight>0 && h>ViewAreaHeight)
				h=ViewAreaHeight;
			if(IsWindow(m_hWnd)){
				BitBlt(m_hDC,0,0,w,h,BackBufferDC,0,0,SRCCOPY);
			}
		}else{
			SetStretchBltMode(m_hDC, COLORONCOLOR);
			if(IsWindow(m_hWnd))
				StretchBlt(m_hDC,0,0,w*2,h*2,BackBufferDC,0,0,w,h,SRCCOPY);
		}
		time1=GetTickCount();
		if(time1>(time2+1000)){
			frame=count;
			count=0;
			time2=time1;
		}else{
			++count;
		}
		if(ShowBenchFlag){
			char moji[256];
			HDC dc=GetWindowDC(m_hWnd);
			wsprintf(moji,"%d[f/s]",frame);
			if(IsWindow(m_hWnd))
				TextOut(dc,Display_Width-100+Display_Width*ZoomFlag,2,moji,strlen(moji));
			ReleaseDC(m_hWnd,dc);
		}
	}
}

void CDraw::SetSprite(int panum, int x, int y, int width, int height, int page)
{
	if(page<0 || page>=MaxSpritePage)
		return;
	if(panum<0 || panum>=MAX_SPRITE)
		return;
	SpritePa[panum].x=x;
	SpritePa[panum].y=y;
	SpritePa[panum].w=width;
	SpritePa[panum].h=height;
	SpritePa[panum].page=page;//ꉞ
}

void CDraw::PutSprite(int num, int x, int y, int pa,int zoomx,int zoomy,int hflag)
{
	if(num<0 || num>MAX_SPRITE)
		return;
	if(pa<0 || pa>=MAX_SPRITE)
		return;
	SpriteAt[num].panum=pa;
	SpriteAt[num].x=x;
	SpriteAt[num].y=y;
	SpriteAt[num].zoomx=zoomx;
	SpriteAt[num].zoomy=zoomy;
	SpriteAt[num].px=SpritePa[pa].x;
	SpriteAt[num].py=SpritePa[pa].y;
	SpriteAt[num].w=SpritePa[pa].w;
	SpriteAt[num].h=SpritePa[pa].h;
	SpriteAt[num].hflag=hflag;
	SpriteAt[num].page=SpritePa[pa].page;//ꉞ

}
void CDraw::EraseSprite(int num)
{//XvCg
	if(num<0 || num>=MAX_SPRITE)
		return;
	SpriteAt[num].panum=-1;

}

void CDraw::InitSprite()
{
	for(int a=0;a<MAX_SPRITE;++a){
		ZeroMemory(&SpriteAt[a],sizeof(SPRITE_ATRIB));
		ZeroMemory(&SpritePa[a],sizeof(SPRITE_PATTERN));
		SpriteAt[a].panum=-1;
	}

}
int CDraw::GetDesktopColor()
{//ʂ̐F𒲂ׂ
	HDC hDC=GetDC(NULL);
	HBITMAP hBmp=CreateCompatibleBitmap(hDC, 1, 1);
	BITMAP Bmp;
	GetObject(hBmp,sizeof(BITMAP),&Bmp);
	DeleteObject(hBmp);
	ReleaseDC(NULL,hDC);
	DesktopColor=Bmp.bmBitsPixel;

	return(DesktopColor);
}

void CDraw::ExitCDraw()
{
	//NX̏I
	SpriteMode=0;

}

void CDraw::ShowBench(int flag)
{
	ShowBenchFlag=flag;
}

void CDraw::SetZoom(int flag)
{
	ZoomFlag=flag;
}
